using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp39
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string red = Console.ReadLine();
            string[] pomocni = red.Split();
            int N = int.Parse(pomocni[0]);
            int M = int.Parse(pomocni[1]);
            int zbir = 0;
            int[,] Doha = new int[N+1, M+1];
            int zbirNReda = 0; int zbirMKolone = 0;
            for (int i = 1; i <= N; i++)
            {
             red =  Console.ReadLine();
             pomocni = red.Split();
                for (int j = 1; j <= M; j++)
                {
                    Doha[i, j] = int.Parse(pomocni[j-1]);
                    if (i == 1) zbirNReda += int.Parse(pomocni[j - 1]);
                    else if (i != 1 && j == M) zbirMKolone += int.Parse(pomocni[j - 1]);
                }
            }
            int Q = int.Parse(Console.ReadLine());
            int[,] zauzeti = new int[Q+1, 3];
            for (int i = 1; i <= Q; i++)
            {
                red = Console.ReadLine();
                pomocni = red.Split();
                zauzeti[i, 1] = int.Parse(pomocni[0]);
                zauzeti[i, 2] = int.Parse(pomocni[1]);
            }
            for (int i = 1; i <= Q; i++)
            {
               zbir = 0;
                if (zauzeti[i, 1] > 1 && zauzeti[i, 2] != M)
                {
                    Console.WriteLine(zbirNReda+zbirMKolone);
                }
                else if(zauzeti[i,1]==1)
                {
                    for (int j = 1, pokazivac = 1; pokazivac <= N;)
                    {
                        if (j == M)
                        {
                            zbir += Doha[pokazivac, j];
                            pokazivac++;
                        }
                        else if (j + 1 != zauzeti[i, 2] && pokazivac == 1)
                        {
                            zbir += Doha[pokazivac, j];
                            j++;
                        }
                     else if(pokazivac==1 && j+1==zauzeti[i,2])
                        {
                            zbir += Doha[pokazivac, j];
                            pokazivac++;
                        }
                        else
                        {
                            zbir += Doha[pokazivac, j];
                            j++;
                        }
                    }
                    Console.WriteLine(zbir);
                }
                else if(zauzeti[i,2]==M)
                {
                    for (int j = 1, pokazivac = 1; pokazivac<=N;)
                    {
                        if (j + 1 != M && pokazivac == 1)
                        {
                            zbir += Doha[pokazivac, j];
                            j++;
                        }
                        else if(j==M-1 && (pokazivac==1 || pokazivac==zauzeti[i,1]))
                        {
                            zbir += Doha[pokazivac, j];
                            pokazivac++;
                        }
                        else if(pokazivac == zauzeti[i, 1] + 1 && j!=M)
                        {
                            zbir += Doha[pokazivac, j];
                            j++;
                        }
                        else if(j==M)
                        {
                            zbir += Doha[pokazivac, j];
                            pokazivac++;
                        }
                    }
                    Console.WriteLine(zbir);
                }
            }
        }
    }
}